/***********************************************************************/
/*                                                                     */
/*                    INTEGRAL SCIENCE DATA CENTRE                     */
/*                                                                     */
/*                      PARAMETER - GUI LIBRARY                        */
/*                                                                     */
/*                                                                     */
/*                                                                     */
/*  File:      param_api.h                                             */
/*  Version:   1.1                                                     */
/*  Developer: Reiner Rohlfs (RR)                                      */
/*             ISDC                                                    */
/*                                                                     */
/*  Revision History:                                                  */
/*                                                                     */
/*  version 1.1: 15/05/03 RR  First version                            */
/*                                                                     */
/***********************************************************************/
#ifndef PARAM_API_INCLUDED
#define PARAM_API_INCLUDED

#include <TApplication.h>

#include <string>
#include <map>

#include "param_gui.h"

class ParamGui
{
   class Api_Support : public Support
   {
   public:
      Api_Support()        {m_paramFileName = NULL; m_quit = true;}

      const char * GetParamFileName()   {return m_paramFileName;}

      void   Save(const char * filename = NULL);
      void   SaveAs(const char * filename);
      void   Terminate()   {m_quit = true; gApplication->Terminate(0);}
      void   Run();

      char        * m_paramFileName;
      char        * m_progName;
      bool        m_quit;

      T_Widgets   m_widgets;
      std::map<std::string, std::string> m_result;

   }    m_support;

   int      m_error;

public:
   ParamGui(int argc, char ** argv, TApplication * app = NULL);

   bool           Quit()   {return m_support.m_quit;}
   int            Error()  {return m_error;}

   bool           GetBool(const char * paraName);
   int            GetInt(const char * paraName);
   double         GetReal(const char * paraName);
   const char *   GetString(const char * paraName);
 
};

#endif // PARAM_API_INCLUDED
