/**************************************************************************************

	I N T E G R A L   S C I E N C E   D A T A   C E N T E R

	P A R A M E T E R   I N T E R F A C E   L I B R A R Y

Copyright:	(c) 1998 ISDC http://obswww.unige.ch/isdc/
File:		pil_f90_bind.c
Description:	Parameter Interface Library - C to F90 binding routines
Authors:	Jerzy.Borkowski@obs.unige.ch (JB)
History:	06-Oct-97 (JB) : support for command line arguments added
		10-May-98 (JB) : PILGetReal4 function added 
		13-May-98 (JB) : version 0.7 released. Code cleanup, unnecesary
			dependencies removed. Uses/links only PIL library. Changes
			to Makefile.
		13-Aug-98 (JB) : version 1.0 released. More compatible with Common
			library some new functions: PILReloadParameters,
			PILFlushParameters, PILGetParFilename, locking of parameter
			file during read/write implemented.
		17-Aug-98 (JB) : reformatted, more comments added
		08-Mar-02 (JB) : SPR 01050 : added PILGetDOL()

**************************************************************************************/


#ifndef PIL_F90_BIND_INCLUDED
#define PIL_F90_BIND_INCLUDED


#define	CFORTRAN_PROTOTYPING

#include <stdio.h>
#include <cfortran.h>
#include <pil.h>



FCALLSCFUN2(LONG, PILGetBool, PILCGETBOOL, pilcgetbool, STRING, INTV)
FCALLSCFUN2(LONG, PILGetInt, PILCGETINT, pilcgetint, STRING, INTV)
FCALLSCFUN2(LONG, PILGetReal, PILGETREAL, pilgetreal, STRING, DOUBLEV)
FCALLSCFUN2(LONG, PILGetReal4, PILGETREAL4, pilgetreal4, STRING, FLOATV)
     /* SPR 3982, call a different funcition so we can init something before
	cfortran gets ahold of it */
FCALLSCFUN2(LONG, PILGetString, PILGETSTRING1, pilgetstring1, STRING, PSTRING)
FCALLSCFUN2(LONG, PILGetFname, PILGETFNAME, pilgetfname, STRING, PSTRING)
FCALLSCFUN2(LONG, PILGetDOL, PILGETDOL, pilgetdol, STRING, PSTRING)

FCALLSCFUN2(LONG, PILPutBool, PILPUTBOOL, pilputbool, STRING, LONG)
FCALLSCFUN2(LONG, PILPutInt, PILPUTINT, pilputint, STRING, LONG)
FCALLSCFUN2(LONG, PILPutReal, PILPUTREAL, pilputreal, STRING, DOUBLE)
FCALLSCFUN2(LONG, PILPutString, PILPUTSTRING, pilputstring, STRING, STRING)
FCALLSCFUN2(LONG, PILPutFname, PILPUTFNAME, pilputfname, STRING, STRING)

FCALLSCFUN1(LONG, PILSetModuleName, PILSETMODULENAME, pilsetmodulename, STRING)
FCALLSCFUN1(LONG, PILSetModuleVersion, PILSETMODULEVERSION, pilsetmoduleversion, STRING)

FCALLSCFUN1(LONG, PILF90AddArg, PILF90ADDARG, pilf90addarg, STRING)

FCALLSCFUN0(LONG, PILF90Init, PILF90INIT, pilf90init)
FCALLSCFUN1(LONG, PILF90Close, PILCLOSE, pilclose, LONG)

extern int pilgetparfilename_(char *A1 , unsigned C1)
 {
   char *B1 = NULL;
   int A0;
   unsigned l;
   

   A0 = PILGetParFilename(&B1);

   if (PIL_OK == A0) if (B1)
     {
       l = strlen(B1);
       memcpy(A1, B1, ((l < C1) ? l : C1));
       if (C1 > l) memset(A1 + l, ' ', C1 - l);
     }

   return A0;
 }


FCALLSCFUN0(LONG, PILLockPFile, PILLOCKPFILE, pillockpfile)
FCALLSCFUN0(LONG, PILUnlockPFile, PILUNLOCKPFILE, pilunlockpfile)

FCALLSCFUN0(LONG, PILFlushParameters, PILFLUSHPARAMETERS, pilflushparameters)
FCALLSCFUN0(LONG, PILReloadParameters, PILRELOADPARAMETERS, pilreloadparameters)

FCALLSCFUN1(LONG, PILOverrideQueryMode, PILOVERRIDEQUERYMODE, piloverridequerymode, LONG)

FCALLSCFUN3(LONG, PILGetIntVector, PILGETINTVECTOR, pilgetintvector, STRING, INT, INTV)
FCALLSCFUN3(LONG, PILGetIntVarVector, PILGETINTVARVECTOR, pilgetintvarvector, STRING, INTV, INTV)
FCALLSCFUN3(LONG, PILGetRealVector, PILGETREALVECTOR, pilgetrealvector, STRING, INT, DOUBLEV)
FCALLSCFUN3(LONG, PILGetRealVarVector, PILGETREALVARVECTOR, pilgetrealvarvector, STRING, INTV, DOUBLEV)
FCALLSCFUN3(LONG, PILGetReal4Vector, PILGETREAL4VECTOR, pilgetreal4vector, STRING, INT, FLOATV)
FCALLSCFUN3(LONG, PILGetReal4VarVector, PILGETREAL4VARVECTOR, pilgetreal4varvector, STRING, INTV, FLOATV)

FCALLSCFUN1(LONG, PILSetReadlinePromptMode, PILSETREADLINEPROMPTMODE, pilsetreadlinepromptmode, LONG)
FCALLSCFUN1(LONG, PILSetCmndArgMode, PILSETCMNDARGMODE, pilsetcmndargmode, LONG)


#endif 		/* PIL_F90_BIND_INCLUDED */
