/**************************************************************************************

	I N T E G R A L   S C I E N C E   D A T A   C E N T E R

	P A R A M E T E R   I N T E R F A C E   L I B R A R Y

Copyright:	(c) 1998 ISDC http://obswww.unige.ch/isdc/
File:		pilcdemo.c
Description:	Parameter Interface Library - sample C program
Authors:	Jerzy.Borkowski@obs.unige.ch (JB)
History:	17-Aug-98 (JB) : version 1.0 release

**************************************************************************************/

/*
 * this program demonstrates how to call PIL library from C code
 * note : this program uses only PIL library (calls PILInit())
 * so it is _NOT_ appropriate for ISDC executables which should
 * call CommonInit(). Should you wish to see sample ISDC compliant
 * program look for it in  Common library directory or see ISDCcopy.c
 * file in this directory.
 *
 * This program does _NOTHING_ useful, it simply displays all
 * parameters from parameter file prompting for new value, if
 * default value is out of range. Program bypasses official API
 * routines, so it is not recommended to follow it. It is included
 * for testing/debug purposes only.
 *
*/


#include <stdio.h>
#include <pil.h>


int	main(int argc, char **argv)
{ char minmaxstr[PIL_LINESIZE+100], modebuf[5];
  PIL_VALUE vmin, vmax;
  PIL_PARAM *pp;
  int r, i;

if (PIL_OK != (r = PILInit(argc, argv)))
  { printf("PILInit failed : %s\n", PIL_err_handler(r));
    return(10);
  } 

for (i=0; i<PILDefaultPFile.pcnt; i++)
 { pp = (PILDefaultPFile.pp)+i;
   switch (pp->format)
    { case PIL_FORMAT_BLANK:
      case PIL_FORMAT_COMMENT:
		printf("%s\n", pp->strline);
		break;
      case PIL_FORMAT_OK:
		minmaxstr[0] = 0;
		if (PIL_OK == PIL_get_range(&PILDefaultPFile, i, &vmin, &vmax))
		  sprintf(minmaxstr, "min=%s, max=%s", pp->strmin, pp->strmax);
		modebuf[0] = 0;
		PIL_mode2string(pp->mode, modebuf);
	        printf("%-16.16s %s %s %20s %s %s\n", pp->strname, PIL_type2string(pp->type),
				modebuf, pp->strvalue, minmaxstr, pp->strprompt);
		switch (pp->type)
		 { case PIL_TYPE_BOOL: PIL_get_bool(&PILDefaultPFile, pp->strname, &(vmin.b)); break;
		   case PIL_TYPE_INT4: PIL_get_int(&PILDefaultPFile, pp->strname, &(vmin.i)); break;
		   case PIL_TYPE_REAL8: PIL_get_real(&PILDefaultPFile, pp->strname, &(vmin.d)); break;
		   case PIL_TYPE_STRING: PIL_get_string(&PILDefaultPFile, pp->strname, vmin.s);
					printf("string returned: %s\n", vmin.s);
		   			break;
		   case PIL_TYPE_FNAME: PIL_get_fname(&PILDefaultPFile, pp->strname, vmin.s);
					printf("string returned: %s\n", vmin.s);
		   			break;
		 }
		modebuf[0] = 0;
		PIL_mode2string(pp->mode, modebuf);
	        printf("%-16.16s %s %s %20s %s %s\n", pp->strname, PIL_type2string(pp->type),
				modebuf, pp->strvalue, minmaxstr, pp->strprompt);
		break;
    }
 }

PILClose(PIL_OK);
return(PIL_OK);
}
