#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include  "pil.h"
#include "param_api.h"

#include "TFAsroFile.h"

//_____________________________________________________________________________
static int ReadParams(char * fileName, int argc, char ** argv)
{
   int status = ISDC_OK;

   for (int par = 1; par < argc; par++)
      if (strcmp("--g",   argv[par]) == 0 ||
          strcmp("--gui", argv[par]) == 0    )
         {
         // use the GUI to ask for the parameters
         ParamGui gui(argc, argv);
         if (gui.Quit())        exit(0);
         if (gui.Error() != ISDC_OK)   return gui.Error();
      
         strcpy(fileName,       gui.GetString("file"));

         return gui.Error();
         }

   do
      {
      status = PILInit(argc, argv);
      if (status != ISDC_OK) break;

      status = PILGetFname("file", fileName);
      if (status != ISDC_OK) break;

      } while (0);

   PILClose(ISDC_OK);

   return status;
}
//_____________________________________________________________________________
int main(int argc, char * argv[])
{
   char fileName[512];

   int status = ReadParams(fileName, argc, argv);
   if (status != ISDC_OK)  return -1;

   Bool_t readOnly = kTRUE;
   TFAsroFile asroFile(fileName, &readOnly);

   printf("\nnum items in file %u\n\n", asroFile.GetNumItems());

   asroFile.Map();

}
